
function XSILoadPlugin( in_reg )
{
	in_reg.Author = "Admin";
	in_reg.Name = "AnimateEnvelopePlugin";
	in_reg.Major = 1;
	in_reg.Minor = 0;

	in_reg.RegisterCommand("SetNewBindPose","SetNewBindPose");
	in_reg.RegisterCommand("ResetRotations","ResetRotations");
	in_reg.RegisterMenu(siMenuTbAnimateDeformEnvelopeID,"SetNewBindPose_Menu",false,false)
	in_reg.RegisterMenu(siMenuTbAnimateDeformEnvelopeID,"ResetRotations_Menu",false,false)
	
	return true;
}

function ResetRotations_Menu_Init( in_ctxt )
{
	oMenu = in_ctxt.Source;
	oMenu.AddCommandItem("Reset Rotations","ResetRotations")
	return true;
}

function SetNewBindPose_Menu_Init( in_ctxt )
{
	oMenu = in_ctxt.Source;
	oMenu.AddCommandItem("Set as New Bind Pose","SetNewBindPose")
	return true;
}

function XSIUnloadPlugin( in_reg )
{
	var strPluginName;
	strPluginName = in_reg.Name;
	Application.LogMessage(strPluginName + " has been unloaded.",siVerbose);
	return true;
}

function ResetRotation_Init( in_ctxt )
{
	var oCmd;
	oCmd = in_ctxt.Source;
	oCmd.Description = "";
	oCmd.ReturnValue = true;
	return true;
}

function SetNewBindPose_Init( in_ctxt )
{
	var oCmd;
	oCmd = in_ctxt.Source;
	oCmd.Description = "";
	oCmd.ReturnValue = true;
	return true;
}

function ResetRotations_Execute(  )
{
	if(Selection.Count != 1 || Selection(0).Type != "polymsh") {
		LogMessage("HOWTO: Select a enveloped polygon mesh object");
		return false;
	}
	sel = Selection(0);
	SelectDeformersFromEnvelope(null);
	ResetTransform(null, siObj, siRot, siXYZ);
	SelectObj(sel);
	
	return true;
}

function SetNewBindPose_Execute(  )
{
	if(Selection.Count != 1 || Selection(0).Type != "polymsh") {
		LogMessage("HOWTO: Select a enveloped polygon mesh object");
		return false;
	}
	if (XSIUIToolkit.MsgBox("About to freeze the modeling stack.", 1)!=1)
		return false;
	sel = Selection(0)+"";
	dup = Duplicate(sel);
	FreezeObj(dup);
	SelectDeformersFromEnvelope(sel);	
	SetEnvelopeRefPoses(null);
	shapekey = SelectShapeKey(sel, dup, siShapeObjectReferenceMode, null, true);	
	FreezeObj(sel+".polymsh.clustershapecombiner");	
	DeleteObj(shapekey);
	try { DeleteObj(sel+".polymsh.cls."+dup+"_ShapeKey"); } catch(e) {}
	if(GetValue(sel+".ShapeWeights").Parameters.Count <= 1) 
		DeleteObj(sel+".ShapeWeights");
	DeleteObj(dup);
	SelectObj(sel);
	
	return true;
}
